/*
 * Created on Mar 10, 2004
 * by Martin Pradny
 * 
 */
 

import java.util.Timer;
import java.util.TimerTask;

/**
 * @author Martin Pradny
 *
 */
public class IterativeSearch {
	private final int maxTime=60;
	private State curState;
	private Timer watchdog;
	private AlphaBetaSearch search;
	private long lastTime=1;
	private long startTime;
	private long curTime;
	private final long maxTimeMs=maxTime*1000;
	private int DEPTHSTEP=2;
	private int depth;
	private State bestState=null;
	protected static boolean terminated=false;
	long lastStartTime;
	
	public void setState(State s){
		curState=s;
	}

	public IterativeSearch(State s, int d){
		curState=s;
		depth=d;
		search=new AlphaBetaSearch(curState,depth);
	}
	public State search(){
		DEPTHSTEP=2;
		bestState=null;
		terminated=false;
		lastTime=1;
		int origDepth=depth;
		depth=depth-DEPTHSTEP;
		startTime=System.currentTimeMillis();
		watchdog = new Timer();
				watchdog.schedule(new TimerTask() {
					public void run() {
						System.out.println("Attempt stopped");
						terminated=true;
						search.stop();
						watchdog.cancel();
					}
				}, maxTime * 1100);
		curTime=System.currentTimeMillis();
		search.bestMove=0;
		search.forcedJump=false;
		System.out.println("Num of pieces " + curState.numOfPieces(curState.turnWhite));
		if (curState.numOfPieces(curState.turnWhite)<2){
			DEPTHSTEP=10;
			depth=1-DEPTHSTEP;
		}
		
		while ((lastTime*4<(startTime+maxTimeMs)-curTime)&&!terminated&&!search.forcedJump&&!(search.bestMove==Integer.MAX_VALUE)){
			depth=depth+DEPTHSTEP;
			search.setDepth(depth);
			search.setState(curState);
			lastStartTime=System.currentTimeMillis();
			search.start();
			while(search.running){
				try {
					Thread.sleep(300);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			if (!terminated || bestState==null){
			 bestState=search.bestState;
			 
			}
			curTime=System.currentTimeMillis();
			lastTime=curTime-lastStartTime;
					
		}
		
		if (terminated){
			depth=depth-DEPTHSTEP;
		}
		if (search.forcedJump){
			depth=depth+DEPTHSTEP;
		}
		System.out.print("Ended on depth " + depth + " terminated " + terminated);
		depth=origDepth+Math.max(-2,Math.min(2,depth-origDepth-DEPTHSTEP));
		watchdog.cancel();
		System.out.print("Next Depth " + depth );
		
		search.addState(bestState);
		return bestState;	
				
				
	}

	/**
	 * @param curState
	 */
	protected void removeState(State s) {
		search.removeState(s);
		
	}
}
