/*
 * Created on 7.3.2004
 * by Martin Pradny
 * 
 */
package ai.checkers;

import java.util.Hashtable;



/**
 * @author Martin Pradny
 *
 */
public class AlphaBetaSearch implements Runnable {
	
	static final int KING_VALUE = 40;
	static final int MAN_VALUE = 30;
	static final int NEXT_TO_VALUE = 1;
	static final int BACK_VALUE = 5;
				
	
	private class IntObject {
		
		public IntObject(int v, int d){
			value=v;
			depth=d;
		}
		protected int value;
		protected int depth;
	}
	
	Thread sThread = null;
	public static boolean running = false;
	private State curState;
	private static int maxDifference;
	private int maxDepth;
	protected boolean forcedJump=false;
	protected int bestMove;
	private static int numWhite;
	private static int numBlack;
	//protected boolean areKings;
	
	private static int nodes=0;
	State bestState;
	
	private Hashtable usedStates=new Hashtable(100);
	private static Hashtable visitedStates=new Hashtable(1000000);
	
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */

	public AlphaBetaSearch(State s, int m) {
		curState = s;
		s.moves = new Stack();
		maxDepth = m;
	}

   public void setDepth(int d){
   	 maxDepth=d;
   }
	public void start() {
		if (sThread == null) {
			sThread = new Thread(this);
			sThread.setPriority(Thread.MAX_PRIORITY);
			//sThread.setPriority(Integer.MAX_VALUE);
			running = true;
			sThread.start();
		}
	}

	public void stop() {
		if (sThread != null) {
			sThread = null;
			running = false;
		}
	}

	public void run() {
		while(Thread.currentThread()!=sThread){
		}
		running=true;
		search();
		stop();
		System.out.print("runnig false");
	}

	public void setState(State s) {
		curState = s;
		s.moves = new Stack();
	}
	

	
	public State search() {
			nodes=0;
			State tmpState;
			int sameValue=0;
			int v;
			int tmpmin;
			boolean pruned = false;
			Stack succStack;
			int ceiling,floor;
		    visitedStates=new Hashtable(1000000);
		    maxDifference = maxDepth / 4;
		    numWhite=curState.numOfPieces(true);
		    numBlack=curState.numOfPieces(false);
		    
			/*
			IntObject ceiling=new IntObject();
			IntObject floor=new IntObject();
			*/
			ceiling=Integer.MAX_VALUE;
			floor=Integer.MIN_VALUE;
			System.out.println("Starting search " + maxDepth);
			bestState=null;
			//int[] tempmax = new int[2]; //Temporary storage for the minmax
			//Just a cast from curState.turnWhite to a int - counting values for the current player
			
		   succStack = curState.genAllSuccessors();
		  v = Integer.MIN_VALUE;
		   if (succStack.isEmpty()) {
						return curState;
					} else {
			
							//precondition for single moves
							tmpState = (State) succStack.pop();
							bestState=tmpState;
			try{
			
			
			
			
				
				if (!succStack.isEmpty()) {
					while (!pruned) {
						
						tmpmin=minValue(tmpState,1,floor,ceiling);
						if (tmpmin>v && (tmpmin<0 ||!usedStates.containsKey(tmpState))){
							sameValue=1;
							v=tmpmin;
							bestState=tmpState;
							
						}else if (tmpmin==v){
							if (tmpmin<0 || !usedStates.containsKey(tmpState)){
								sameValue++;
								if (1.0/sameValue>Math.random()) bestState=tmpState;
							}
													
						}
						if (v >= ceiling) {
							//pruned = true;
						} else {
							floor=Math.max(floor,v);
						}
						if (succStack.isEmpty()) {
							pruned=true;}
						else{	 
						 tmpState = (State) succStack.pop();
						}
						
					}
					
					System.out.println("I can reach " +v);
				}else{
					forcedJump=true;
				}
			 
				
			}catch (OutOfTimeException e){
				System.out.print("Out of time");
			}
			}
		        
				System.out.println("Nodes:"+nodes );
		        System.out.println("Hash load:" + visitedStates.size() );
		        visitedStates=null;
				if (bestState==null) {bestState=tmpState;System.out.print("Forced last");} 
				bestMove=v;
				System.out.println(usedStates.size());
				return bestState;
				
			}

		
		
		
	private int minValue(State s,int depth, int floor,int ceiling) throws OutOfTimeException {
			
			Stack sStack = new Stack();
			State tmpState;
			int v;
			boolean pruned = false;
			int tmpv;
			//int[] tempmax = new int[2]; //Temporary storage for the minmax
			 
			
			//s.moves=new Stack();
		   sStack = s.genAllSuccessors();
			if ( sStack.isEmpty()) {
									return Integer.MIN_VALUE;
		   }else{
			if (depth >= maxDepth) { 
						return utility(s,curState.turnWhite);
					} else {
				v = Integer.MAX_VALUE;
				
				while (!sStack.isEmpty() && !pruned) {
					tmpState = (State) sStack.pop();
					if (!visitedStates.containsKey(tmpState)){
					
					//areKings=areKings||tmpState.areKings;
					v = Math.min(v, maxValue(tmpState,depth+1, floor, ceiling));
					visitedStates.put(tmpState,new IntObject(v,depth));
					} else {
						if (((IntObject)visitedStates.get(tmpState)).depth-maxDifference>depth) {
																			visitedStates.remove(tmpState);
																			v = Math.min(v, maxValue(tmpState,depth+1, floor, ceiling));
																			visitedStates.put(tmpState,new IntObject(v,depth));
																		}else{
						v=((IntObject)visitedStates.get(tmpState)).value;}
					}
					//Max value from oponent choose;
					if (v < floor) {
						pruned = true;
					} else {
						ceiling = Math.min(ceiling, v);
					}
				}
			
				return v;
			}

		}
	}
		
	private int maxValue(State s,int depth, int floor,int ceiling) throws OutOfTimeException {
				
				Stack sStack = new Stack();
				State tmpState;
				int v;
				int tmpv;
				boolean pruned = false;
				//int[] tempmax = new int[2]; //Temporary storage for the minmax
				 
				
		         sStack = s.genAllSuccessors();
		         if ( sStack.isEmpty()) {
		         			 //System.out.println(s.toString());	
							 return Integer.MAX_VALUE;
				}else{
				
							 
				if (depth >= maxDepth) { 
					return utility(s,curState.turnWhite);
				} else {		
					v = Integer.MIN_VALUE;
				
					while (!sStack.isEmpty() && !pruned) {
						tmpState = (State) sStack.pop();
						if (!visitedStates.containsKey(tmpState)){
						//areKings=areKings||tmpState.areKings;
						v = Math.max(v, minValue(tmpState,depth+1, floor, ceiling));
						visitedStates.put(tmpState,new IntObject(v,depth));
											} else {
												if (((IntObject)visitedStates.get(tmpState)).depth-maxDifference>depth) {
													visitedStates.remove(tmpState);
													v = Math.max(v, minValue(tmpState,depth+1, floor, ceiling));
													visitedStates.put(tmpState,new IntObject(v,depth));
												}else{
												 v=((IntObject)visitedStates.get(tmpState)).value;}
											}
						//Max value from oponent choose;
						if (v > ceiling) {
							pruned = true;
						} else {
							floor = Math.max(floor, v);
						}
					}
			
					return v;
				}

			}
	}		
	public void removeState(State s){
			usedStates.remove(s);
		}
	
	public void addState(State s){
				usedStates.put(s,"1");
			}	
	/*		
	public State nonrecSearch(){
		nodes=0;
		Stack stateStack=new Stack();
		State tmpState;
		State child;
		State fakeState=new State();
		fakeState.playsMax=false;
		fakeState.v=Integer.MIN_VALUE;
		curState.ceiling=Integer.MAX_VALUE;
		curState.floor=Integer.MIN_VALUE;		
		
		
		curState.ceiling=Integer.MAX_VALUE;
		curState.floor=Integer.MIN_VALUE;		
		curState.v=Integer.MIN_VALUE;
		curState.playsMax=true;
		curState.parent=fakeState;
		curState.moves=new Stack();
		curState.expanded=false;
		curState.depth=0;
		curState.bestChild=null;
		stateStack.push(curState);
		
		
		
		while(!stateStack.isEmpty()){
			tmpState=(State)stateStack.top();
			if (tmpState.depth<maxDepth){
			  if (!tmpState.expanded) {
				tmpState.successors=tmpState.genAllSuccessors();
				tmpState.expanded=true;
			  }
			  }else{
			  	tmpState.successors=new Stack();
			  	tmpState.v=utility(tmpState,curState.turnWhite);
			  }
			  if (!tmpState.successors.isEmpty()) {
			    child=(State)tmpState.successors.pop();
				child.floor=tmpState.floor;
				child.ceiling=tmpState.ceiling;
				child.depth=tmpState.depth+1;
				child.playsMax=!tmpState.playsMax;
				child.parent=tmpState;
				child.v=(child.playsMax)?Integer.MIN_VALUE:Integer.MAX_VALUE;
				stateStack.push(child);
			} else {
				if (tmpState.parent.playsMax){
					if (tmpState.parent.v<tmpState.v){
						tmpState.parent.bestChild=tmpState;
						tmpState.parent.v=tmpState.v;
					}
					tmpState.parent.floor=Math.max(tmpState.parent.floor,tmpState.v);
				} else {
					if (tmpState.parent.v>tmpState.v){
											tmpState.parent.bestChild=tmpState;
											tmpState.parent.v=tmpState.v;
					}
					tmpState.parent.ceiling=Math.min(tmpState.parent.ceiling,tmpState.v);
				}
				stateStack.pop();
			}
		   
				
		}
		System.out.println("Nodes:"+nodes);
		return curState.bestChild;
				
	}
	*/
	
	private static int utility(State s, boolean player) throws OutOfTimeException {
		if (!running) throw new OutOfTimeException();
		return utilityFinal(s,player);
		
	}
	
	private static int utility2(State s, boolean player) {
			int red=0;
			int white=0;
			int util;
		    nodes++;
			for (int i = 0; i < 32; i++) {
				if (s.getData(i,0)) {
					if (s.getData(i,1)) {
						white++;
					} else {
						red++;
					}
				}
			}

			
			if (player) {
				util=red-white;
			} else {
				util=white-red;
			}
			//System.out.println(player);
			return util;
			
		}
		
	private static int utility3(State s, boolean player) {
			 int h = 0;
			 int A,B,C,D;
			 for (int i = 0; i < 32; i++) {
			 A = State.moveA(i);
			
			 B = State.moveB(i);
			
			 C = State.moveC(i);
			
			 D = State.moveD(i);
		
        
                  
				 if (s.getData(i,0))  {     
					if (s.getData(i,1)== player)   {   // if i is and white plays for MAX, or if i is black and black plays for MAX
                    
						if ((A!=-1) && (s.getData(A,0)) && (s.getData(A,1) == player)) h = h - NEXT_TO_VALUE;                              // if the surrounding place contains a piece
						if ((B!=-1) && (s.getData(B,0)) && (s.getData(B,1) == player)) h = h - NEXT_TO_VALUE;	
						if ((C!=-1) && (s.getData(C,0)) && (s.getData(C,1) == player)) h = h - NEXT_TO_VALUE;
						if ((D!=-1) && (s.getData(D,0)) && (s.getData(D,1) == player)) h = h - NEXT_TO_VALUE;
											
						if (s.getData(i,2)) h = h - MAN_VALUE;
						else h = h - KING_VALUE; 
                   		
                   		//if (((i > 27) && (i < 32)) || (i==11)||(i==19)||(i==12)||(i==4)) h = h - BACK_VALUE;	
                  
					   }
				   else {
					    if ((A!=-1) && (s.getData(A,0)) && (s.getData(A,1) == !player)) h = h + NEXT_TO_VALUE;                              // if the surrounding place contains a piece
						if ((B!=-1) && (s.getData(B,0)) && (s.getData(B,1) == !player)) h = h + NEXT_TO_VALUE;	
						if ((C!=-1) && (s.getData(C,0)) && (s.getData(C,1) == !player)) h = h + NEXT_TO_VALUE;
						if ((D!=-1) && (s.getData(D,0)) && (s.getData(D,1) == !player)) h = h + NEXT_TO_VALUE;
											
						if (s.getData(i,2)) h = h + MAN_VALUE;
						else h = h + KING_VALUE;                                                   // i is black - playing for min
				   }
             
		  if (player) {
		  if (s.getData(i,1)&&((i == 28)||(i==29)||(i==30)||(i==31)||(i==11)||(i==19)||(i==12)||(i==4))) h = h - BACK_VALUE;
		  if (!(s.getData(i,1))&&((i == 0)||(i==1)||(i==2) ||(i==3)||(i==11)||(i==19)||(i==12)||(i==4))) h = h + BACK_VALUE;
		  }
		  else {
		  if (s.getData(i,1)&&((i == 28)||(i==29)||(i==30)||(i==31)||(i==11)||(i==19)||(i==12)||(i==4))) h = h + BACK_VALUE;
		  if (!(s.getData(i,1))&&((i == 0)||(i==1)||(i==2)||(i==3)||(i==11)||(i==19)||(i==12)||(i==4))) h = h - BACK_VALUE;    
		  }
				 }
			 } 
    
        
		return h;
		}
		
		
	private static int utilityFinal(State s, boolean player){
		int t;
		int a,b;
		int hB;
		int hW;
		//number of pieces;
		int hNumB=0;
		int hNumW=0;
		//number of kings;
		int hNumKB=0;
		int hNumKW=0;
		//number of kings;
		int hNumAdjacentB=0;
		int hNumAdjacentW=0;
		// opened king positions ;
	    int hNumKingOpenB=0;
		int hNumKingOpenW=0;
        //	opened king positions ;
		int hNumNotJumpB=0;
		int hNumNotJumpW=0;
		// opened king positions ;
		int hNumDistB=0;
		int hNumDistW=0;
		
		int util;
	
		for (int i = 0; i < 32; i++) {
			if (s.getData(i,0)){ 
			a=State.moveA(i);
			b=State.moveB(i);
			if (s.getData(i,1)) 
			                       {
			                       	hNumW++;
			                       	if (!s.getData(i,2)) hNumKW++;
									if (a!=-1 && s.getData(a,1)) hNumAdjacentW++;
									if (b!=-1 && s.getData(b,1)) hNumAdjacentW++;
									if (s.getData(i,2)){
									if (i==24 && !s.getData(28,0)) hNumKingOpenW++;
									if (i==24 && !s.getData(29,0)) hNumKingOpenW++;
									if (i==25 && !s.getData(29,0)) hNumKingOpenW++;
									if (i==25 && !s.getData(30,0)) hNumKingOpenW++;
									if (i==26 && !s.getData(30,0)) hNumKingOpenW++;
									if (i==26 && !s.getData(31,0)) hNumKingOpenW++;
									}
									
									if ((i<5)||(i==11)||(i==12)||(i==19)||(i==20)||(i>26)) hNumNotJumpW++;
			                       	if (i<4) hNumNotJumpW++;
									hNumDistW=hNumDistW+Math.abs(7-(i & -2))+Math.abs(3-(i & 1));
			                       	 
			                       	}
			                    else {
			                    	
			                    	hNumB++;    
			                    	
									if (!s.getData(i,2)) hNumKB++;
									if (a!=-1&& !s.getData(a,1)) hNumAdjacentB++;
									if (b!=-1&& !s.getData(b,1)) hNumAdjacentB++;
									if (s.getData(i,2)){
									if (i==5 && !s.getData(0,0)) hNumKingOpenB++;
									if (i==5 && !s.getData(1,0)) hNumKingOpenB++;
									if (i==6 && !s.getData(1,0)) hNumKingOpenB++;
									if (i==6 && !s.getData(2,0)) hNumKingOpenB++;
									if (i==7 && !s.getData(2,0)) hNumKingOpenB++;
									if (i==7 && !s.getData(3,0)) hNumKingOpenB++;
									}			                    
									if ((i<5)||(i==11)||(i==12)||(i==19)||(i==20)||(i>26)) hNumNotJumpB++;
									if (i>27) hNumNotJumpW++;
									
									hNumDistB=hNumDistB+Math.abs(7-(i & -2))+Math.abs(3-(i & 1));
											                    
			                    }
			}                    
	    }
	    
	  
	    
	   if (player) {
	   				if (numWhite>4) {
					   hB=((numBlack-hNumB)<<8)-(hNumB<<6)-(hNumKB<<7)-(hNumAdjacentB<<5)+(hNumKingOpenB<<4)-(hNumNotJumpB<<8)-(hNumDistB<<2);
					   hW=((numWhite-hNumW)<<8)-(hNumW<<6)-(hNumKW<<7)-(hNumAdjacentW<<5)+(hNumKingOpenW<<4)-(hNumNotJumpW<<8)-(hNumDistW<<2);
	   	
	   				} else {
						hB=((numBlack-hNumB)<<8)-(hNumKB<<5)-(hNumAdjacentB<<4)-(hNumNotJumpB<<8);
		     		    hW=((numWhite-hNumW)<<8)-(hNumKW<<5)-(hNumAdjacentW<<4)-(hNumNotJumpW<<8);
	   	
	   				}
					   util=hW-hB;
				   } else {
						if (numBlack>4) {
								hB=((numBlack-hNumB)<<8)-(hNumB<<6)-(hNumKB<<7)-(hNumAdjacentB<<5)+(hNumKingOpenB<<4)-(hNumNotJumpB<<8)-(hNumDistB<<2);
							   hW=((numWhite-hNumW)<<8)-(hNumW<<6)-(hNumKW<<7)-(hNumAdjacentW<<5)+(hNumKingOpenW<<4)-(hNumNotJumpW<<8)-(hNumDistW<<2);
	   	
							} else {
							hB=((numBlack-hNumB)<<8)-(hNumKB<<5)-(hNumAdjacentB<<4)-(hNumNotJumpB<<8);
						   hW=((numWhite-hNumW)<<8)-(hNumKW<<5)-(hNumAdjacentW<<4)-(hNumNotJumpW<<8);
							}
					   util=hB-hW;
				   }
					   
	  //System.out.println(player);
	  return util;	
	}
	
	private static int utility4(State s, boolean player) {
				 int h = 0;
				 int A,B,C,D;
				 for (int i = 0; i < 32; i++) {
				 A = State.moveA(i);
			
				 B = State.moveB(i);
			
				 C = State.moveC(i);
			
				 D = State.moveD(i);
		
        
                  
					 if (s.getData(i,0))  {     
						if (s.getData(i,1)== player)   {   // if i is and white plays for MAX, or if i is black and black plays for MAX
                    
							if ((A!=-1) && (s.getData(A,0))) {                                     // if the surrounding place contains a piece
								if ((s.getData(A,1) == s.getData(i,1))) h = h - NEXT_TO_VALUE;        // if the color of pos i = pos A 
								else {
									if (s.getData(i,2)) h = h + MAN_VALUE;      
									else h = h + KING_VALUE;
								 }
								 }
							if ((B!=-1) && (s.getData(B,0))) {
								if ((s.getData(B,1) == s.getData(i,1))) h = h - NEXT_TO_VALUE;         
								else {
									if (s.getData(i,2)) h = h + MAN_VALUE;      
									else h = h + KING_VALUE;
								 }
								 }
						   if ((C!=-1) && (s.getData(C,0))) {
								if ((s.getData(C,1) == s.getData(i,1))) h = h - NEXT_TO_VALUE;         
								else {
									if (s.getData(i,2)) h = h + MAN_VALUE;      
									else h = h + KING_VALUE;
								 }
								 }
							if ((D!=-1) && (s.getData(D,0))) {
								if ((s.getData(D,1) == s.getData(i,1))) h = h - NEXT_TO_VALUE;         
								else {
									if (s.getData(i,2)) h = h + MAN_VALUE;      
									else h = h + KING_VALUE;
								 }
								 }
							if (s.getData(i,2)) h = h - MAN_VALUE;
							else h = h - KING_VALUE; 
                   
                  
						   }
					   else {                                                  // i is black - playing for min
							if ((A!=-1) && (s.getData(A,0))) {                                     // if the surrounding place contains a piece
								if ((s.getData(A,1) == s.getData(i,1))) h = h + NEXT_TO_VALUE;        // if the color of pos i = pos A 
								else {
									if (s.getData(i,2)) h = h - MAN_VALUE;      
									else h = h - KING_VALUE;
								 }
								 }
							//System.out.println(s.data[B][0]+"BLAAAAAAAA");  
							if ((B!=-1) && (s.getData(B,0))) {
								if ((s.getData(B,1) == s.getData(i,1))) h = h + NEXT_TO_VALUE;         
								else {
									if (s.getData(i,2)) h = h - MAN_VALUE;      
									else h = h - KING_VALUE;
								 }
								 }
						   if ((C!=-1) && (s.getData(C,0))) {
								if ((s.getData(C,1) == s.getData(i,1))) h = h + NEXT_TO_VALUE;         
								else {
									if (s.getData(i,2)) h = h - MAN_VALUE;      
									else h = h - KING_VALUE;
								 }
								 }
							if ((D!=-1) && (s.getData(D,0))) {
								if ((s.getData(D,1) == s.getData(i,1))) h = h + NEXT_TO_VALUE;         
								else {
									if (s.getData(i,2)) h = h - MAN_VALUE;      
									else h = h - KING_VALUE;
								 }
								 }
							if (s.getData(i,2)) h = h + MAN_VALUE;
							else h = h + KING_VALUE;
							}
             
			  if (player) {
			  if (s.getData(i,1)&&((i == 28)||(i==29)||(i==30)||(i==31)||(i==11)||(i==19)||(i==12)||(i==4))) h = h - BACK_VALUE;
			  if (!(s.getData(i,1))&&((i == 0)||(i==1)||(i==2) ||(i==3)||(i==11)||(i==19)||(i==12)||(i==4))) h = h + BACK_VALUE;
			  }
			  else {
			  if (s.getData(i,1)&&((i == 28)||(i==29)||(i==30)||(i==31)||(i==11)||(i==19)||(i==12)||(i==4))) h = h + BACK_VALUE;
			  if (!(s.getData(i,1))&&((i == 0)||(i==1)||(i==2)||(i==3)||(i==11)||(i==19)||(i==12)||(i==4))) h = h - BACK_VALUE;    
			  }
					 }
				 } 
    
        
			return h;
			}
	
	
}
